diff --git a/rathaxes/samples/e1000/e1000.blt b/rathaxes/samples/e1000/e1000.blt
--- a/rathaxes/samples/e1000/e1000.blt
+++ b/rathaxes/samples/e1000/e1000.blt
@@ -701,326 +140,721 @@
         }
     }
 
-    /* TODO: make that a method of e1000::Context */
-    template sequence   e1000::print_status(Ethernet::Device rtx_ether_ctx)
+    template type e1000::RxDescriptor()
     {
-        chunk   LKM::prototypes()
+        decl data_types()
+        {
+            __le64          buff_addr;
+            __le16          length;
+            __le16          csum;
+            unsigned char   status;
+            unsigned char   errors;
+            __le16          special;
+        }
+
+        map
+        {
+        }
+    }
+
+    // This is a generic tx descriptor for the e1000. When you use TCP
+    // Segmentation Offload (TSO) the hardware actually uses two types of
+    // tx descriptors in its tx ring:
+    // - context descriptors: this descriptor doesn't actually point to data to
+    //   send but initialize the offloading engine for the data descriptor that
+    //   follow;
+    // - data descriptors: this descriptor points to data from the skbuffs.
+    template type e1000::TxDescriptor()
+    {
+        decl data_types()
+        {
+            __le64                  buff_addr;
+            union {
+                __le32              data;
+                struct {
+                    __le16          length;
+                    unsigned char   csum_offset; /* CSO */
+                    unsigned char   cmd;
+                }                   fields;
+            }                       lower;
+            union {
+                __le32              data;
+                struct {
+                    unsigned char   status;
+                    unsigned char   csum_start; /* CSS */
+                    __le16          special;
+                }                   fields;
+            }                       upper;
+        }
+
+        map
+        {
+        }
+    }
+
+    template type e1000::Buffer()
+    {
+        decl data_types()
+        {
+            ${Socket::SKBuff}   sk_buff;
+            ${DMA::DMAHandle}   dma;
+        }
+
+        method init(Socket::SKBuff sk_buff, DMA::DMAHandle dma)
+        {
+            ${self.sk_buff} = ${sk_buff};
+            ${self.dma} = ${dma};
+        }
+
+        map
+        {
+            sk_buff: ${self}->sk_buff;
+            dma: ${self}->dma;
+        }
+    }
+
+    template type e1000::Context()
+    {
+        decl data_types()
+        {
+            ${Ethernet::Device.ref} net_dev;
+            // XXX should be annoted with __iomem:
+            unsigned char           *io_addr;
+            // XXX Forced to hardcode the type because there is a circular
+            // dependency between the rings and the context.
+            rtxType_e1000_TxRing    tx_ring;
+            rtxType_e1000_RxRing    rx_ring;
+        }
+
+        chunk LKM::includes()
+        {
+            #include <linux/types.h>
+        }
+
+        chunk LKM::prototypes()
         {
             static void rtx_e1000_print_status(${e1000::Context.ref});
+
+            // XXX Needed until we can call methods (issue #46):
+            static unsigned int rtx_e1000_reg_read32(${e1000::Context}, ${e1000::Register});
+            static void rtx_e1000_reg_write32(${e1000::Context}, ${e1000::Register}, unsigned int);
+            static void rtx_e1000_reg_set32(${e1000::Context}, ${e1000::Register}, unsigned int);
+            static void rtx_e1000_reg_unset32(${e1000::Context}, ${e1000::Register}, unsigned int);
         }
 
-        chunk   LKM::code()
+        chunk LKM::code()
         {
-            static void rtx_e1000_print_status(${e1000::Context.ref} hw_ctx)
+            static void rtx_e1000_print_status(${e1000::Context.ref} self)
             {
-                unsigned int status = rtx_e1000_register_read32(hw_ctx, E1000_STATUS);
-                    ${Log::info("card status:")};
-                /*
-                 * we can't use Log::info below because it just accept a string
-                 * (as opposed to a format string with its parameters).
-                 */
+                unsigned int status = rtx_e1000_reg_read32(${local.self}, E1000_STATUS);
+                ${Log::info("card status:")};
+                // XXX We can't use Log::info below because it just accepts a
+                // string (as opposed to a format string with its arguments):
                 pr_info("\tRegister value: 0x%x\n", status);
                 pr_info("\tMode: %s\n", (status & 1) ? "Full": "Half");
                 pr_info("\tLink: %s\n", (status & 2) ? "Up" : "Down");
                 pr_info("\tTransmission: %s\n", (status & 4) ? "Paused" : "Ok");
                 pr_info("\tInterface: %s\n", (status & 3) == 3 ? "Up" : "Down");
             }
+
+            static unsigned int rtx_e1000_reg_read32(${e1000::Context} self, ${e1000::Register} reg)
+            {
+                // XXX The compiler generates &self->io_addr instead of
+                // self->io_addr if I use ${local.self.io_addr}:
+                return ioread32(self->io_addr + reg);
+            }
+
+            static void rtx_e1000_reg_write32(${e1000::Context} self,
+                                              ${e1000::Register} reg,
+                                              unsigned int value)
+            {
+                return iowrite32(value, self->io_addr + reg);
+            }
+
+            static void rtx_e1000_reg_set32(${e1000::Context} self,
+                                            ${e1000::Register} reg,
+                                            unsigned int value)
+            {
+                return iowrite32(
+                    rtx_e1000_reg_read32(${local.self}, reg) | value,
+                    self->io_addr + reg
+                );
+            }
+
+            static void rtx_e1000_reg_unset32(${e1000::Context} self,
+                                              ${e1000::Register} reg,
+                                              unsigned int value)
+            {
+                return iowrite32(rtx_e1000_reg_read32(
+                    ${local.self}, reg) & ~value,
+                    self->io_addr + reg
+                );
+            }
         }
 
-        chunk   ::CALL()
+        method init(Ethernet::Device rtx_ether_ctx, Builtin::symbol io_addr)
         {
-            rtx_e1000_print_status(&${rtx_ether_ctx}->hw_ctx);
+            ${self.net_dev} = ${rtx_ether_ctx};
+            ${self.io_addr} = ${io_addr};
+        }
+
+        method reg_read32(e1000::Register reg)
+        {
+            ioread32(${self.io_addr} + ${local.reg});
+        }
+
+        method reg_write32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(${value}, ${self.io_addr} + ${reg});
+        }
+
+        method reg_set32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(ioread32(${self.io_addr} + ${reg}) | ${value}, ${self.io_addr} + ${reg});
+        }
+
+        method reg_unset32(e1000::Register reg, Builtin::number value)
+        {
+            iowrite32(ioread32(${self.io_addr} + ${reg}) & ~${value}, ${self.io_addr} + ${reg});
+        }
+
+        chunk Ethernet::HardwareContext()
+        {
+            ${e1000::Context} hw_ctx;
+        }
+
+        chunk Ethernet::adapter_init_context(Ethernet::Device rtx_ether_ctx, Builtin::symbol io_addr)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+                // XXX doesn't work: ${local.hw_ctx.init(rtx_ether_ctx, io_addr)};
+                ${local.hw_ctx.net_dev} = ${rtx_ether_ctx};
+                ${local.hw_ctx.io_addr} = ${io_addr};
+                // XXX doesn't work: ${local.hw_ctx.rx_ring.init(local.hw_ctx, config.rx_ring_size)};
+                rtx_e1000_ring_init(
+                    &${local.hw_ctx.rx_ring},
+                    ${config.rx_ring_size},
+                    sizeof(rtxType_e1000_RxDescriptor)
+                );
+                // XXX doesn't work: ${local.hw_ctx.tx_ring.init(local.hw_ctx, config.tx_ring_size)};
+                rtx_e1000_ring_init(
+                    &${local.hw_ctx.tx_ring},
+                    ${config.tx_ring_size},
+                    sizeof(rtxType_e1000_TxDescriptor)
+                );
+            }
+        }
+
+        chunk Ethernet::adapter_reset(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+                // XXX #46: ${local.hw_ctx.io.write32(E1000_CTRL, E1000_CMD_RST)};
+                rtx_e1000_reg_write32(hw_ctx, E1000_CTRL, E1000_CMD_RST);
+                udelay(10); // TODO: abstract udelay too...
+                ${Log::info("adapter has been reset")};
+            }
+        }
+
+        chunk Ethernet::adapter_load_mac_address(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+                // Shamelessly borrowed from Minix
+                for (int i = 0; i < 3; ++i) {
+                    rtx_e1000_reg_write32(hw_ctx, E1000_EEPROM_READ, (i << 8) | 1);
+                    int value;
+                    do {
+                        value = rtx_e1000_reg_read32(hw_ctx, E1000_EEPROM_READ);
+                    } while ((value & (1 << 4)) == 0);
+                    value >>= 16;
+                    // NOTE: I'm not sure if Ethernet::Device should be
+                    // accessed directly here. But since we need to take it in
+                    // parameter (so we can get back our e1000::Context) it
+                    // seems inadequate to set this in another way:
+                    ${rtx_ether_ctx.dev_addr}[i * 2] = value & 0xff;
+                    ${rtx_ether_ctx.dev_addr}[i * 2 + 1] = (value >> 8) & 0xff;
+                }
+
+                ${Log::info("mac address loaded from the EEPROM")};
+            }
+        }
+
+        // For e1000, this part is documented in the Intel Gigabit Ethernet
+        // Controller Software Developper manual. (You can find it in the
+        // doc/hardware directory).
+        chunk Ethernet::adapter_setup_rx_tx(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+
+                // "General Configuration" (section 14.3):
+                //
+                // - CTRL.ASDE/CTRL.SLU: Let the PHY handle the speed detection &
+                //   negociation;
+                // - CTRL.LRST/FRCSPD: Unset them to initiate the auto-negociation;
+                // - CTRL.PHY_RST: Unset it;
+                // - CTRL.ILOS: Unset it (ILOS is Invert Loss Of Signal);
+                // - CTRL.VME: Make sure it's not set to disable VLAN support;
+                // - Set the control flow registers to 0;
+                // - Finally, initialize all the statistic registers from
+                //   E1000_CRCERRS to E1000_TSCTFC.
+
+                // XXX #46: Use the read/write/set/unset methods on Context
+                rtx_e1000_reg_set32(hw_ctx, E1000_CTRL, E1000_CMD_ASDE|E1000_CMD_SLU);
+                rtx_e1000_reg_unset32(
+                    hw_ctx,
+                    E1000_CTRL,
+                    E1000_CMD_LRST|E1000_CMD_FRCSPD|E1000_CMD_PHY_RST|
+                    E1000_CMD_ILOS|E1000_CMD_VME
+                );
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCAH, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCAL, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCT, 0);
+                rtx_e1000_reg_write32(hw_ctx, E1000_FCTTV, 0);
+                // XXX int i leaks from another chunk and will not be generated
+                // here, let's use a different index name:
+                for (int j = 0; j != 64; ++j)
+                    rtx_e1000_reg_write32(hw_ctx, E1000_CRCERRS + j * 4, 0);
+
+                ${Log::info("adapter_setup_rx_tx: general configuration done")};
+
+                int err;
+
+                err = rtx_e1000_rx_ring_alloc_resources(&hw_ctx->rx_ring);
+                if (err)
+                    goto err_alloc_rx_ring;
+                rtx_e1000_rx_ring_configure(&hw_ctx->rx_ring);
+
+                err = rtx_e1000_tx_ring_alloc_resources(&hw_ctx->tx_ring);
+                if (err)
+                    goto err_alloc_tx_ring;
+                rtx_e1000_tx_ring_configure(&hw_ctx->tx_ring);
+
+                err_alloc_tx_ring:
+                    rtx_e1000_rx_ring_free_resources(&hw_ctx->rx_ring);
+                err_alloc_rx_ring:
+                    // XXX Can't return here since we don't know the context,
+                    // anyway, hardcoded goto:
+                    goto rtx_ethernet_open_fail;
+            }
+        }
+
+        chunk Ethernet::adapter_enable_interrupts(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+                rtx_e1000_reg_write32(
+                    ${local.hw_ctx},
+                    E1000_IMS,
+                    E1000_INTR_TXDW|E1000_INTR_TXQE|E1000_INTR_LSC|
+                    E1000_INTR_RXO|E1000_INTR_RXT0
+                );
+
+                // XXX We should probably move that elsewhere (it just used to
+                // be done right after we enabled interrupts when this was
+                // still in lkm.rtx):
+                // XXX #46: ${local.hw_ctx.print_status()};
+                rtx_e1000_print_status(${local.hw_ctx});
+            }
+        }
+
+        chunk Ethernet::adapter_disable_interrupts(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_disable_interrupts: TBD...")}; }
+        }
+
+        chunk Ethernet::adapter_handle_interrupt(Ethernet::Device rtx_ether_ctx)
+        {
+            {
+                ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+                unsigned int icr = rtx_e1000_reg_read32(hw_ctx, E1000_ICR);
+                pr_info("%s: interrupt received, ICR: 0x%x", ${config.name}, icr);
+                if (icr) {
+                    if (icr & E1000_INTR_LSC) {
+                        ${Log::info("handle_interrupt: cable link status changed, dumping card status:")};
+                        // XXX #46: ${local.hw_ctx.print_status()};
+                        rtx_e1000_print_status(hw_ctx);
+                    }
+                    if (icr & (E1000_INTR_TXQE|E1000_INTR_TXDW)) {
+                        ${Log::info("handle_interrupt: TxRing: packet(s) sent")};
+                    }
+                    if (icr & E1000_INTR_RXT0) {
+                        ${Log::info("handle_interrupt: RxRing: packet(s) received")};
+                    }
+                    if (icr & E1000_INTR_RXO) {
+                        ${Log::info("handle_interrupt: RxRing: overrun")};
+                    }
+
+                    // XXX: This sucks since we don't know the pointcut context:
+                    return IRQ_HANDLED;
+                }
+            }
+        }
+
+        chunk Ethernet::adapter_xmit(Ethernet::Device rtx_ether_ctx, Socket::SKBuff rtx_skb)
+        {
+            { ${Log::info("adapter_xmit: TBD...")}; }
+        }
+
+        chunk Ethernet::adapter_disable_rx(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_disable_rx: TBD..")}; }
+        }
+
+        chunk Ethernet::adapter_disable_tx(Ethernet::Device rtx_ether_ctx)
+        {
+            { ${Log::info("adapter_disable_tx: TBD..")}; }
+        }
+
+        chunk Ethernet::adapter_free_rx_tx(Ethernet::Device rtx_ether_ctx)
+        {
+            ${e1000::Context.ref} hw_ctx = &${rtx_ether_ctx}->hw_ctx;
+
+            { ${Log::info("adapter_free_rx_tx: TBD..")}; }
+
+            rtx_e1000_rx_ring_free_resources(${local.hw_ctx.rx_ring});
+            rtx_e1000_tx_ring_free_ressources(${local.hw_ctx.tx_ring});
+        }
+
+        method print_status()
+        {
+            rtx_e1000_print_status(${self});
+        }
+
+        map
+        {
+            io_addr: ${self}->io_addr;
+            rx_ring: ${self}->rx_ring;
+            tx_ring: ${self}->tx_ring;
+            net_dev: ${self}->net_dev;
         }
     }
 
-    /*
-     * We should have been able to do something along those lines, but
-     * it didn't work so we made the call manually.
-     *
-     * Ideally:
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, E1000_STATUS)};
-     *
-     * Ideally2, not sure about the syntax on the register parameter:
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, ${e1000::Register.E1000_STATUS})};
-     *
-     * "Acceptable":
-     * ${e1000::Register} reg_status;
-     * ${e1000.init(E1000_STATUS); // didn't work, so we used the next line
-     * reg_status = E1000_STATUS;
-     * ${e1000::register_read32(rtx_ether_ctx->hw_ctx, reg_status)};
-     *
-     * TODO: make them methods of e1000::Context
-     */
-    template sequence   e1000::register_read32(e1000::Context ctx, e1000::Register reg_offset)
+    template type e1000::Ring()
     {
-        chunk   LKM::prototypes()
+        decl data_types()
         {
-            /* FIXME: See issue #54 */
-            static unsigned int    rtx_e1000_register_read32(/*const*/ ${e1000::Context.ref}, unsigned int);
+            ${e1000::Context}       hw_ctx;
+            ${DMA::DMAHandle}       dma;
+            unsigned int            size;
+            ${Builtin::symbol.ref}  descs;
+            ${e1000::Buffer.ref}    buffs;
         }
 
-        chunk   LKM::code()
+        chunk LKM::prototypes()
         {
-            /* FIXME: See issue #54 */
-            static unsigned int    rtx_e1000_register_read32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset)
+            static void rtx_e1000_ring_init(${e1000::Ring.ref}, ${e1000::Context}, int, int);
+        }
+
+        chunk LKM::code()
+        {
+            static void rtx_e1000_ring_init(${e1000::Ring.ref} self, ${e1000::Context} hw_ctx,
+                                            int desc_count, int desc_size)
             {
-                return ioread32(ctx->ioaddr + reg_offset);
+                BUG_ON(desc_count <= 0 || desc_size <= 0);
+                memset(self, 0, sizeof(*self));
+                self->size = ALIGN(desc_count * desc_size, 4096);
+                self->hw_ctx = hw_ctx;
             }
         }
 
-        chunk   ::CALL()
+        method init(e1000::Context hw_ctx, Builtin::number desc_count, Builtin::number desc_size)
         {
-            rtx_e1000_register_read32(${ctx}, ${reg_offset});
+            rtx_e1000_ring_init(&${self}, ${hw_ctx}, ${desc_count}, ${desc_size});
+        }
+
+        map
+        {
+            hw_ctx: ${self}->hw_ctx;
+            dma: ${self}->dma;
+            size: ${self}->size;
+            descs: ${self}->descs;
+            buffs: ${self}->buffs;
         }
     }
 
-    template sequence   e1000::register_write32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
+    template type e1000::RxRing()
     {
-        chunk   LKM::prototypes()
+        decl data_types()
         {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_write32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
+            ${e1000::Ring}  ring;
         }
 
-        chunk   LKM::code()
+        chunk LKM::prototypes()
         {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_write32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
+            static int rtx_e1000_rx_ring_alloc_resources(${e1000::RxRing.ref});
+            static void rtx_e1000_rx_ring_free_resources(${e1000::RxRing.ref});
+            static void rtx_e1000_rx_ring_configure(${e1000::RxRing.ref});
+        }
+
+        chunk LKM::code()
+        {
+            static int rtx_e1000_rx_ring_alloc_resources(${e1000::RxRing.ref} self)
             {
-                iowrite32(value, ctx->ioaddr + reg_offset);
+                // 4. Setup the receive descriptor ring
+
+                int i;
+
+                // Allocate the descriptors
+                ${local.self.descs} = ${DMA::alloc_coherent(
+                    local.self.hw_ctx.net_dev.device, local.self.size,
+                    local.self.dma.dma_handle
+                )};
+
+                if (!${local.self.descs}) {
+                    ${Log::info("adapter_init_rx: cannot allocate the descriptors for the rx ring")};
+                    goto err_rx_ring_alloc;
+                }
+
+                // XXX The generated code is totally wrong if this is not scoped:
+                { ${Log::info("adapter_init_rx: rx descriptors allocated")}; }
+
+                // Allocate the skbuffs, map them for DMA, and write their address
+                // in the corresponding descriptor.
+                for (i = 0; i != ${config.rx_ring_size}; ++i) {
+                    // XXX No support for arrays:
+                    ${e1000::Buffer.ref} buff = &${local.self.buffs}[i];
+                    // XXX #46: ${rtx_ether_ctx.alloc_rx_skbuff(local.buff.skbuff, config.rx_buffer_len)};
+                    if (rtx_ethernet_alloc_rx_skbuff(&${local.buff.sk_buff}, ${config.rx_buffer_len})) {
+                        ${Log::info("adapter_init_rx: cannot allocate a skbuff for the rx ring")};
+                        goto err_skbuffs_alloc;
+                    }
+                    // XXX I couldn't manage to get this call working:
+                    //${local.buff.dma.dma_handle} = ${DMA::map(
+                    //    local.self.hw_ctx.net_dev.device, local.buff.sk_buff.data,
+                    //    config.rx_buffer_len, RTX_DMA_FROM_DEVICE
+                    //)};
+                    ${local.buff.dma.dma_handle.k_dma_handle} = dma_map_single(
+                        ${local.self.hw_ctx.net_dev.device.k_device}, ${local.buff.sk_buff.data},
+                        ${config.rx_buffer_len}, RTX_DMA_FROM_DEVICE
+                    );
+                    int err = ${DMA::mapping_error(
+                        local.self.hw_ctx.net_dev.device, local.buff.dma.dma_handle
+                    )};
+                    if (err) {
+                        ${Log::info("adapter_init_rx: cannot dma-map a skbuff for the rx ring")};
+                        goto err_skbuffs_map;
+                    }
+                    ${local.self.descs}[i].buff_addr = cpu_to_le64(${local.buff.dma.dma_handle.k_dma_handle});
+                }
+
+                { ${Log::info("adapter_init_rx: skbuffs allocated")}; }
+
+                return 0;
+
+            err_skbuffs_alloc:
+                while (i--) {
+                    ${e1000::Buffer.ref} buff = &${local.self.buffs}[i];
+                    // XXX I couldn't manage to get this call working
+                    //${DMA::unmap(
+                    //    local.self.hw_ctx.net_dev.device,
+                    //    local.buff.dma.dma_handle,
+                    //    config.rx_buffer_len,
+                    //    RTX_DMA_FROM_DEVICE
+                    //)};
+                    dma_unmap_single(
+                        ${local.self.hw_ctx.net_dev.device.k_device},
+                        ${local.buff.dma.dma_handle.k_dma_handle},
+                        ${config.rx_buffer_len},
+                        RTX_DMA_FROM_DEVICE
+                    );
+            err_skbuffs_map:
+                    // XXX #46: ${local.buff.sk_buff.free()};
+                    dev_kfree_skb(${local.buff.sk_buff.sk_buff.k_sk_buff});
+                }
+
+                void *descs = ${local.self.descs};
+                ${cast local.descs as Builtin::symbol.ref};
+                ${DMA::free_coherent(
+                    local.self.hw_ctx.net_dev.device, local.self.size,
+                    local.descs, local.self.dma.dma_handle
+                )};
+            err_rx_ring_alloc:
+                return -ENOMEM;
+            }
+
+            static void rtx_e1000_rx_ring_free_resources(${e1000::RxRing.ref} self)
+            {
+                ${Log::info("e1000_rx_ring_free_resources: TBD...")};
+            }
+
+            static void rtx_e1000_rx_ring_configure(${e1000::RxRing.ref} self)
+            {
+                // Receive initialization (section 14.4):
+                //
+                // 1. Program the receive address, in RAL/RAH;
+                // 2. Initialize the Multicast Table Array;
+                // 3. Program the interrupt mask register (done in
+                //    e1000::activate_device_interruption);
+                // 4. Allocate the receive descriptor ring and map it to make it
+                //    accessible by the device;
+                // 5. Write the start address of the ring in RDBAL/RDBAH and set
+                //    RDLEN (Receive Descriptor Length) to the size of the ring;
+                // 6. Set the RDH/RDT (Receive Descriptor Head/Tail) indexes to the
+                //    beginning and end of the ring;
+                // 7. Make sure that RCTL.BSIZE and .BSEX are at 0 to configure the
+                //    receive buffer size to 2048 bytes (e1000::rx_buffer_len).
+                // 8. Set RCTL.EN to enable the receiver.
+                //
+                // The ugly casts here are caused by the lack of CNorm unstrict.
+
+                int i;
+
+                // 1. Program the receive address
+
+                // (We should use uint{32,16}_t but CNorm doesn't know them yet)
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RAL,
+                    *(unsigned int *)(${local.self.hw_ctx.net_dev.dev_addr})
+                );
+                // The 16 upper bits of RAH also store the AS bits (which should be
+                // 0) and the AV bit (should be 1 to set the address as valid).
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RAH,
+                    *(unsigned short *)(&${local.self.hw_ctx.net_dev.dev_addr}[4])
+                );
+                rtx_e1000_reg_set32(${local.self.hw_ctx}, E1000_RAH, E1000_RAH_AV);
+
+                ${Log::info("rx_ring_configure: receive address programmed")};
+
+                // 2. Initialize the MTA
+
+                for (i = 0; i != 128; ++i) // TODO Remove that hardcoded 128
+                    rtx_e1000_reg_write32(${local.self.hw_ctx}, E1000_MTA + i * 4, 0);
+
+                ${Log::info("rx_ring_configure: MTA init done")};
+
+                // 5. Save the emplacement and the size of the ring in RDBA/RDLEN
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RDBAL,
+                    ${local.self.dma.dma_handle.k_dma_handle} & 0xffffffff
+                );
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RDBAH,
+                    ${local.self.dma.dma_handle.k_dma_handle} >> 32
+                );
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RDLEN,
+                    ${local.self.size}
+                );
+
+                // 6. Setup RDH/RDT
+                rtx_e1000_reg_write32(${local.self.hw_ctx}, E1000_RDH, 0);
+                rtx_e1000_reg_write32(
+                    ${local.self.hw_ctx}, E1000_RDT,
+                    ${config.rx_ring_size} - 1
+                );
+
+                // 7. Configure the buffer size
+                rtx_e1000_reg_set32(
+                    ${local.self.hw_ctx}, E1000_RCTL,
+                    E1000_RCTL_BSIZE_${config.rx_buffer_len}
+                );
+
+                // 8. Enable the receiver
+                rtx_e1000_reg_set32(${local.self.hw_ctx}, E1000_RCTL, E1000_RCTL_EN);
+
+                ${Log::info("rx_ring_configure: receive registers configured and receiver enabled")};
+
+                return 0;
             }
         }
 
-        chunk   ::CALL()
+        method init(e1000::Context hw_ctx, Builtin::number desc_count)
         {
-            rtx_e1000_register_write32(${ctx}, ${reg_offset}, ${value});
+            // XXX doesn't work: ${self.ring.init(hw_ctx, desc_count, self.desc_size)};
+            rtx_e1000_ring_init(&${self}, ${hw_ctx}, ${desc_count}, ${self.desc_size});
+        }
+
+        method alloc()
+        {
+            rtx_e1000_rx_ring_alloc_resources(${self});
+        }
+
+        method free()
+        {
+            rtx_e1000_rx_ring_free_resources(${self});
+        }
+
+        method configure()
+        {
+            rtx_e1000_rx_ring_configure(${self});
+        }
+
+        map
+        {
+            hw_ctx: ${self}->ring.hw_ctx;
+            dma: ${self}->ring.dma;
+            size: ${self}->ring.size;
+            descs: ${self}->ring.descs;
+            buffs: ${self}->ring.buffs;
+            desc_size: sizeof(rtxType_e1000_RxDescriptor); // XXX hardcoded
         }
     }
 
-    template sequence   e1000::register_set32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
+    template type e1000::TxRing()
     {
-        chunk   LKM::prototypes()
+        decl data_types()
         {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_set32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
+            ${e1000::Ring}  ring;
         }
 
-        chunk   LKM::code()
+        chunk LKM::prototypes()
         {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_set32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
+            static int rtx_e1000_tx_ring_alloc_resources(${e1000::TxRing.ref});
+            static void rtx_e1000_tx_ring_free_resources(${e1000::TxRing.ref});
+            static void rtx_e1000_tx_ring_configure(${e1000::TxRing.ref});
+        }
+
+        chunk LKM::code()
+        {
+            static int rtx_e1000_tx_ring_alloc_resources(${e1000::TxRing.ref} self)
             {
-                iowrite32(rtx_e1000_register_read32(ctx, reg_offset) | value, ctx->ioaddr + reg_offset);
+                ${Log::info("e1000_tx_ring_alloc_resources: TBD...")};
+                return 0;
+            }
+
+            static void rtx_e1000_tx_ring_free_resources(${e1000::TxRing.ref} self)
+            {
+                ${Log::info("e1000_tx_ring_free_resources: TBD...")};
+            }
+
+            static void rtx_e1000_tx_ring_configure(${e1000::TxRing.ref} self)
+            {
+                ${Log::info("e1000_tx_ring_configure: TBD...")};
             }
         }
 
-        chunk   ::CALL()
+        method init(e1000::Context hw_ctx, Builtin::number desc_count)
         {
-            rtx_e1000_register_set32(${ctx}, ${reg_offset}, ${value});
-        }
-    }
-
-    template sequence   e1000::register_unset32(e1000::Context ctx, e1000::Register reg_offset, ::number value)
-    {
-        chunk   LKM::prototypes()
-        {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_unset32(/*const*/ ${e1000::Context.ref}, unsigned int, unsigned int);
+            // XXX doesn't work: ${self.ring.init(hw_ctx, desc_count, self.desc_size)};
+            rtx_e1000_ring_init(&${self}, ${hw_ctx}, ${desc_count}, ${self.desc_size});
         }
 
-        chunk   LKM::code()
+        method alloc()
         {
-            /* FIXME: See issue #54 */
-            static void rtx_e1000_register_unset32(/*const*/ ${e1000::Context.ref} ctx, unsigned int reg_offset, unsigned int value)
-            {
-                iowrite32(rtx_e1000_register_read32(ctx, reg_offset) & ~value, ctx->ioaddr + reg_offset);
-            }
+            rtx_e1000_tx_ring_alloc_resources(${self});
         }
 
-        chunk   ::CALL()
+        method free()
         {
-            rtx_e1000_register_unset32(${ctx}, ${reg_offset}, ${value});
+            rtx_e1000_tx_ring_free_resources(${self});
         }
-    }
 
-    template sequence   activate_device_interruption(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk  ::CALL()
+        method configure()
         {
-            rtx_e1000_register_write32(&${rtx_ether_ctx}->hw_ctx, E1000_IMS,
-                                       E1000_INTR_TXDW |
-                                       E1000_INTR_TXQE |
-                                       E1000_INTR_LSC  |
-                                       E1000_INTR_RXO  |
-                                       E1000_INTR_RXT0);
+            rtx_e1000_tx_ring_configure(${self});
         }
-    }
 
-    /* TODO:
-     *
-     * Refactor into two methods (one in RxRing and one in TxRing) and make use
-     * of the new methods in Socket::SKBuff.
-     */
-    template sequence   free_rx_tx(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk   ::CALL()
+        map
         {
-            /*
-             * XXX: Not generated if named "hw_ctx" (which is funny because
-             * it's used and works in the template right above this one):
-             */
-            ${e1000::Context.ref} hw_ctx_;
-            hw_ctx_ = &${rtx_ether_ctx}->hw_ctx;
-
-            /*
-             * Free the rx ring:
-             * - Unmap and free the skbuffs;
-             * - Free the descriptors array.
-             */
-            for (int i = 0; i != ${config.rx_ring_size}; ++i)
-            {
-                /*
-                 * XXX Leaking casts:
-                 *
-                 * We should go through the rtx types (Socket::SKBuff,
-                 * AbstractSKBuff), but we can't because of the array here,
-                 * which is not supported by the compiler.
-                 */
-                dma_unmap_single(
-                        ${rtx_ether_ctx.device},
-                        *((dma_addr_t *)&(hw_ctx_->rx_ring.skbuffs[i].dma_handle)),
-                        ${config.rx_buffer_len},
-                        DMA_FROM_DEVICE);
-                dev_kfree_skb((struct sk_buff *)hw_ctx_->rx_ring.skbuffs[i].skbuff);
-            }
-            dma_free_coherent(${rtx_ether_ctx.device}, hw_ctx_->rx_ring.size,
-                    hw_ctx_->rx_ring.base, hw_ctx_->rx_ring.dma_base);
-            ${Log::info("free_rx_tx: rx ring free'ed")};
-
-            /*
-             * Free the tx ring:
-             * - Free the descriptors array.
-             */
-            dma_free_coherent(${rtx_ether_ctx.device}, hw_ctx_->tx_ring.size,
-                    hw_ctx_->tx_ring.base, hw_ctx_->tx_ring.dma_base);
-            ${Log::info("free_rx_tx: tx ring free'ed")};
-        }
-    }
-
-    template sequence   handle_interrupt(Ethernet::Device rtx_ether_ctx)
-    {
-        chunk   ::CALL()
-        {
-            unsigned int icr = rtx_e1000_register_read32(&${rtx_ether_ctx}->hw_ctx, E1000_ICR);
-            pr_info("%s: interrupt received, ICR: 0x%x", ${config.name}, icr);
-            if (icr)
-            {
-                if (icr & E1000_INTR_LSC)
-                {
-                    ${Log::info("handle_interrupt: cable link status changed, dumping card status:")};
-                    ${e1000::print_status(rtx_ether_ctx)};
-                }
-                if (icr & (E1000_INTR_TXQE|E1000_INTR_TXDW))
-                {
-                    ${Log::info("handle_interrupt: TxRing: packet(s) sent")};
-                    /*
-                     * XXX Do a Rathaxes call (how can I bind
-                     * "&${rtx_ether_ctx}->hw_ctx.tx_ring" to e1000::TxRing easily?)
-                     */
-                    rtx_e1000_tx_ring_clean(&${rtx_ether_ctx}->hw_ctx.tx_ring);
-                }
-                if (icr & E1000_INTR_RXT0)
-                {
-                    ${Log::info("handle_interrupt: RxRing: packet(s) received")};
-                }
-                if (icr & E1000_INTR_RXO)
-                {
-                    ${Log::info("handle_interrupt: RxRing: overrun")};
-                }
-
-                return IRQ_HANDLED;
-            }
-        }
-    }
-
-    template sequence   e1000::xmit(Ethernet::Device rtx_ether_ctx, Socket::AbstractSKBuff kernel_skb)
-    {
-        chunk   ::CALL()
-        {
-            /*
-             * Put packets on the TX ring, must return NETDEV_TX_OK or
-             * NETDEV_TX_BUSY.
-             */
-
-            ${Socket::SKBuff} skb;
-            ${e1000::Context.ref} hw_ctx;
-            ${e1000::TxRing.ref} tx_ring;
-            ${Device::AbstractDevice.ref} devp;
-
-            ${local.skb.init(kernel_skb)};
-            hw_ctx = &${rtx_ether_ctx}->hw_ctx;
-            tx_ring = &hw_ctx->tx_ring;
-            devp = (${Device::AbstractDevice.ref})${rtx_ether_ctx.device};
-
-            ${Log::info("xmit: skbuff details:")};
-            /*
-             * skb does not expand on the bound C variable (should be
-             * rtx_skbuff), which is funny because it works for the
-             * sequence template call right after.
-             */
-            /*
-             * XXX: doesn't work (I tried to pass self explicitely too):
-             * ${local.skb.dump_infos()};
-             */
-            rtx_socket_skbuff_dump_infos(&skb);
-
-            /*
-             * The transmission is going to be several steps:
-             * 1. TCP Segmentation Offload & Checksum Offloading: pick a
-             *    descriptor from the tx ring and fill it as a context
-             *    descriptor to allow the card to slice into several packets
-             *    according to the MSS;
-             * 2. DMA Map the skbuff data as slices of 4096;
-             * 3. Signal the hardware that data is available via a tx desc.
-             */
-
-            /* XXX: same thing wanted to use: ${local.tx_ring.descriptors_remaining()} */
-            if (!rtx_e1000_tx_ring_descriptors_remaining(tx_ring))
-                return NETDEV_TX_BUSY;
-
-            /* 1. Offloading */
-
-            /* XXX: ${local.tx_ring.tso_cksum_offload(skb)}; */
-            if (rtx_e1000_tx_ring_tso_cksum_offload(tx_ring, &skb))
-            {
-                ${Log::info("xmit: the packet needs to be fragmented and/or checksummed but this not implemented yet!")};
-                goto err_offload;
-            }
-
-            /* 2. Map the data */
-
-            /* XXX: ${local.skb.map_to(devp.k_device)}; */
-            if (rtx_socket_skbuff_map(&skb, ${devp.k_device}, DMA_TO_DEVICE))
-            {
-                ${Log::info("xmit: can't DMA map a SKbuff")};
-                goto err_skb_map_to;
-            }
-
-            /* 3. Update the TX Ring and signal the hardware */
-
-            /* XXX: ${local.tx_ring.put(skb)}; */
-            rtx_e1000_tx_ring_put(tx_ring, &skb);
-
-            /* XXX: ${local.tx_ring.start_xmit(hw_ctx)}; */
-            rtx_e1000_tx_ring_start_xmit(tx_ring, hw_ctx);
-
-            return NETDEV_TX_OK;
-
-        err_offload:
-        err_skb_map_to:
-            /* XXX: ${local.skb.unmap_to_and_free(local.dev)}; */
-            rtx_socket_skbuff_unmap_and_free(&skb, ${devp.k_device}, DMA_TO_DEVICE);
-            return NETDEV_TX_OK;
+            hw_ctx: ${self}->ring.hw_ctx;
+            dma: ${self}->ring.dma;
+            size: ${self}->ring.size;
+            descs: ${self}->ring.descs;
+            buffs: ${self}->ring.buffs;
+            desc_size: sizeof(rtxType_e1000_TxDescriptor); // XXX hardcoded
         }
     }
 }
